ICU 74.2 74.2

Public Member Functions | Static Public Member Functions | Data Fields | Friends
icu::RuleBasedBreakIterator Class Reference

A subclass of BreakIterator whose behavior is specified using a list of rules. More...

`#include <rbbi.h>`

Inheritance diagram for icu::RuleBasedBreakIterator:

## Public Member Functions
| RuleBasedBreakIterator ()
| Default constructor. More...
| RuleBasedBreakIterator (const RuleBasedBreakIterator &that)
| Copy constructor. More...
| RuleBasedBreakIterator (const UnicodeString &rules, UParseError &parseError, UErrorCode &status)
| Construct a RuleBasedBreakIterator from a set of rules supplied as a string. More...
| RuleBasedBreakIterator (const uint8_t *compiledRules, uint32_t ruleLength, UErrorCode &status)
| Construct a RuleBasedBreakIterator from a set of precompiled binary rules. More...
| RuleBasedBreakIterator (UDataMemory *image, UErrorCode &status)
| This constructor uses the udata interface to create a BreakIterator whose internal tables live in a memory-mapped file. More...
virtual | ~RuleBasedBreakIterator ()
| Destructor. More...
RuleBasedBreakIterator & | operator= (const RuleBasedBreakIterator &that)
| Assignment operator. More...
virtual bool | operator== (const BreakIterator &that) const override
| Equality operator. More...
bool | operator!= (const BreakIterator &that) const
| Not-equal operator. More...
virtual RuleBasedBreakIterator * | clone () const override
| Returns a newly-constructed RuleBasedBreakIterator with the same behavior, and iterating over the same text, as this one. More...
virtual int32_t | hashCode (void) const
| Compute a hash code for this BreakIterator. More...
virtual const UnicodeString & | getRules (void) const
| Returns the description used to create this iterator. More...
virtual CharacterIterator & | getText (void) const override
virtual UText * | getUText (UText *fillIn, UErrorCode &status) const override
| Get a UText for the text being analyzed. More...
virtual void | adoptText (CharacterIterator *newText) override
| Set the iterator to analyze a new piece of text. More...
virtual void | setText (const UnicodeString &newText) override
| Set the iterator to analyze a new piece of text. More...
virtual void | setText (UText *text, UErrorCode &status) override
| Reset the break iterator to operate over the text represented by the UText. More...
virtual int32_t | first (void) override
| Sets the current iteration position to the beginning of the text, position zero. More...
virtual int32_t | last (void) override
| Sets the current iteration position to the end of the text. More...
virtual int32_t | next (int32_t n) override
| Advances the iterator either forward or backward the specified number of steps. More...
virtual int32_t | next (void) override
| Advances the iterator to the next boundary position. More...
virtual int32_t | previous (void) override
| Moves the iterator backwards, to the last boundary preceding this one. More...
virtual int32_t | following (int32_t offset) override
| Sets the iterator to refer to the first boundary position following the specified position. More...
virtual int32_t | preceding (int32_t offset) override
| Sets the iterator to refer to the last boundary position before the specified position. More...
virtual UBool | isBoundary (int32_t offset) override
| Returns true if the specified position is a boundary position. More...
virtual int32_t | current (void) const override
| Returns the current iteration position. More...
virtual int32_t | getRuleStatus () const override
| Return the status tag from the break rule that determined the boundary at the current iteration position. More...
virtual int32_t | getRuleStatusVec (int32_t *fillInVec, int32_t capacity, UErrorCode &status) override
| Get the status (tag) values from the break rule(s) that determined the boundary at the current iteration position. More...
virtual UClassID | getDynamicClassID (void) const override
| Returns a unique class ID POLYMORPHICALLY. More...
virtual RuleBasedBreakIterator * | createBufferClone (void *stackBuffer, int32_t &BufferSize, UErrorCode &status) override
| Deprecated functionality. More...
virtual const uint8_t * | getBinaryRules (uint32_t &length)
| Return the binary form of compiled break rules, which can then be used to create a new break iterator at some time in the future. More...
virtual RuleBasedBreakIterator & | refreshInputText (UText *input, UErrorCode &status) override
| Set the subject text string upon which the break iterator is operating without changing any other aspect of the matching state. More...
void | dumpCache ()
| Debugging function only. More...
void | dumpTables ()
| Debugging function only. More...
Public Member Functions inherited from icu::BreakIterator
virtual | ~BreakIterator ()
| destructor More...
bool | operator!= (const BreakIterator &rhs) const
| Returns the complement of the result of operator==. More...
UBool | isBufferClone (void)
| Determine whether the BreakIterator was created in user memory by createBufferClone(), and thus should not be deleted. More...
Locale | getLocale (ULocDataLocaleType type, UErrorCode &status) const
| Returns the locale for this break iterator. More...
const char * | getLocaleID (ULocDataLocaleType type, UErrorCode &status) const
| Get the locale for this break iterator object. More...
Public Member Functions inherited from icu::UObject
virtual | ~UObject ()
| Destructor. More...

## Static Public Member Functions
static UClassID | getStaticClassID (void)
| Returns the class ID for this class. More...
static void | registerExternalBreakEngine (ExternalBreakEngine *toAdopt, UErrorCode &status)
| Register a new external break engine. More...
Static Public Member Functions inherited from icu::BreakIterator
static BreakIterator * | createWordInstance (const Locale &where, UErrorCode &status)
| Create BreakIterator for word-breaks using the given locale. More...
static BreakIterator * | createLineInstance (const Locale &where, UErrorCode &status)
| Create BreakIterator for line-breaks using specified locale. More...
static BreakIterator * | createCharacterInstance (const Locale &where, UErrorCode &status)
| Create BreakIterator for character-breaks using specified locale Returns an instance of a BreakIterator implementing character breaks. More...
static BreakIterator * | createSentenceInstance (const Locale &where, UErrorCode &status)
| Create BreakIterator for sentence-breaks using specified locale Returns an instance of a BreakIterator implementing sentence breaks. More...
static BreakIterator * | createTitleInstance (const Locale &where, UErrorCode &status)
| Create BreakIterator for title-casing breaks using the specified locale Returns an instance of a BreakIterator implementing title breaks. More...
static const Locale * | getAvailableLocales (int32_t &count)
| Get the set of Locales for which TextBoundaries are installed. More...
static UnicodeString & | getDisplayName (const Locale &objectLocale, const Locale &displayLocale, UnicodeString &name)
| Get name of the object for the desired Locale, in the desired language. More...
static UnicodeString & | getDisplayName (const Locale &objectLocale, UnicodeString &name)
| Get name of the object for the desired Locale, in the language of the default locale. More...
static URegistryKey | registerInstance (BreakIterator *toAdopt, const Locale &locale, UBreakIteratorType kind, UErrorCode &status)
| Register a new break iterator of the indicated kind, to use in the given locale. More...
static UBool | unregister (URegistryKey key, UErrorCode &status)
| Unregister a previously-registered BreakIterator using the key returned from the register call. More...
static StringEnumeration * | getAvailableLocales (void)
| Return a StringEnumeration over the locales available at the time of the call, including registered locales. More...

## Data Fields
RBBIDataWrapper * | fData = nullptr
| The rule data for this BreakIterator instance. More...

## Friends
class | RBBIRuleBuilder
class | BreakIterator

## Additional Inherited Members
Public Types inherited from icu::BreakIterator
enum | { DONE = (int32_t)-1 }
Protected Member Functions inherited from icu::BreakIterator
| BreakIterator ()
| BreakIterator (const BreakIterator &other)
| BreakIterator (const Locale &valid, const Locale &actual)
BreakIterator & | operator= (const BreakIterator &other)

## Detailed Description

A subclass of BreakIterator whose behavior is specified using a list of rules.

Instances of this class are most commonly created by the factory methods of BreakIterator::createWordInstance(), BreakIterator::createLineInstance(), etc., and then used via the abstract API in class BreakIterator

See the ICU User Guide for information on Break Iterator Rules.

This class is not intended to be subclassed.

Definition at line 120 of file rbbi.h.

## Constructor & Destructor Documentation

## ◆ RuleBasedBreakIterator() [1/5]

icu::RuleBasedBreakIterator::RuleBasedBreakIterator | ( |  | ) |

Default constructor.

Creates an empty shell of an iterator, with no rules or text to iterate over. Object can subsequently be assigned to, but is otherwise unusable.

Stable:
  ICU 2.2

## ◆ RuleBasedBreakIterator() [2/5]

icu::RuleBasedBreakIterator::RuleBasedBreakIterator | ( | const RuleBasedBreakIterator & | that | ) |

Copy constructor.

Will produce a break iterator with the same behavior, and which iterates over the same text, as the one passed in.

Parameters

  that | The RuleBasedBreakIterator passed to be copied

Stable:
  ICU 2.0

## ◆ RuleBasedBreakIterator() [3/5]

icu::RuleBasedBreakIterator::RuleBasedBreakIterator | ( | const UnicodeString & | rules,
|  | UParseError & | parseError,
|  | UErrorCode & | status
| ) |  |

Construct a RuleBasedBreakIterator from a set of rules supplied as a string.

Parameters

  rules | The break rules to be used.
  parseError | In the event of a syntax error in the rules, provides the location within the rules of the problem.
  status | Information on any errors encountered.

Stable:
  ICU 2.2

## ◆ RuleBasedBreakIterator() [4/5]

icu::RuleBasedBreakIterator::RuleBasedBreakIterator | ( | const uint8_t * | compiledRules,
|  | uint32_t | ruleLength,
|  | UErrorCode & | status
| ) |  |

Construct a RuleBasedBreakIterator from a set of precompiled binary rules.

Binary rules are obtained from RulesBasedBreakIterator::getBinaryRules(). Construction of a break iterator in this way is substantially faster than construction from source rules.

Ownership of the storage containing the compiled rules remains with the caller of this function. The compiled rules must not be modified or deleted during the life of the break iterator.

The compiled rules are not compatible across different major versions of ICU. The compiled rules are compatible only between machines with the same byte ordering (little or big endian) and the same base character set family (ASCII or EBCDIC).

See also
  getBinaryRules

Parameters

  compiledRules | A pointer to the compiled break rules to be used.
  ruleLength | The length of the compiled break rules, in bytes. This corresponds to the length value produced by getBinaryRules().
  status | Information on any errors encountered, including invalid binary rules.

Stable:
  ICU 4.8

## ◆ RuleBasedBreakIterator() [5/5]

icu::RuleBasedBreakIterator::RuleBasedBreakIterator | ( | UDataMemory * | image,
|  | UErrorCode & | status
| ) |  |

This constructor uses the udata interface to create a BreakIterator whose internal tables live in a memory-mapped file.

"image" is an ICU UDataMemory handle for the pre-compiled break iterator tables.

Parameters

  image | handle to the memory image for the break iterator data. Ownership of the UDataMemory handle passes to the Break Iterator, which will be responsible for closing it when it is no longer needed.
  status | Information on any errors encountered.

See also
  udata_open
  getBinaryRules

Stable:
  ICU 2.8

## ◆ ~RuleBasedBreakIterator()

virtual icu::RuleBasedBreakIterator::~RuleBasedBreakIterator | ( |  | ) |
| virtual

Destructor.

Stable:
  ICU 2.0

## Member Function Documentation

## ◆ adoptText()

virtual void icu::RuleBasedBreakIterator::adoptText | ( | CharacterIterator * | newText | ) |
| override virtual

Set the iterator to analyze a new piece of text.

This function resets the current iteration position to the beginning of the text.

Parameters

  newText | An iterator over the text to analyze. The BreakIterator takes ownership of the character iterator. The caller MUST NOT delete it!

Stable:
  ICU 2.0

Implements icu::BreakIterator.

## ◆ clone()

virtual RuleBasedBreakIterator* icu::RuleBasedBreakIterator::clone | ( |  | ) | const
| override virtual

Returns a newly-constructed RuleBasedBreakIterator with the same behavior, and iterating over the same text, as this one.

Differs from the copy constructor in that it is polymorphic, and will correctly clone (copy) a derived class. clone() is thread safe. Multiple threads may simultaneously clone the same source break iterator.

Returns
  a newly-constructed RuleBasedBreakIterator

Stable:
  ICU 2.0

Implements icu::BreakIterator.

## ◆ createBufferClone()

virtual RuleBasedBreakIterator* icu::RuleBasedBreakIterator::createBufferClone | ( | void * | stackBuffer,
|  | int32_t & | BufferSize,
|  | UErrorCode & | status
| ) |  |
| override virtual

Deprecated functionality.

Use clone() instead.

Create a clone (copy) of this break iterator in memory provided by the caller. The idea is to increase performance by avoiding a storage allocation. Use of this function is NOT RECOMMENDED. Performance gains are minimal, and correct buffer management is tricky. Use clone() instead.

Parameters

  stackBuffer | The pointer to the memory into which the cloned object should be placed. If nullptr, allocate heap memory for the cloned object.
  BufferSize | The size of the buffer. If zero, return the required buffer size, but do not clone the object. If the size was too small (but not zero), allocate heap storage for the cloned object.
  status | Error status. U_SAFECLONE_ALLOCATED_WARNING will be returned if the provided buffer was too small, and the clone was therefore put on the heap.

Returns
  Pointer to the clone object. This may differ from the stackBuffer address if the byte alignment of the stack buffer was not suitable or if the stackBuffer was too small to hold the clone.

Deprecated:
  ICU 52. Use clone() instead.

Implements icu::BreakIterator.

## ◆ current()

virtual int32_t icu::RuleBasedBreakIterator::current | ( | void |  | ) | const
| override virtual

Returns the current iteration position.

Note that UBRK_DONE is never returned from this function; if iteration has run to the end of a string, current() will return the length of the string while next() will return UBRK_DONE).

Returns
  The current iteration position.

Stable:
  ICU 2.0

Implements icu::BreakIterator.

## ◆ dumpCache()

void icu::RuleBasedBreakIterator::dumpCache | ( |  | ) |

Debugging function only.

Internal:
  Do not use. This API is for internal use only.

## ◆ dumpTables()

void icu::RuleBasedBreakIterator::dumpTables | ( |  | ) |

Debugging function only.

Internal:
  Do not use. This API is for internal use only.

## ◆ first()

virtual int32_t icu::RuleBasedBreakIterator::first | ( | void |  | ) |
| override virtual

Sets the current iteration position to the beginning of the text, position zero.

Returns
  The offset of the beginning of the text, zero.

Stable:
  ICU 2.0

Implements icu::BreakIterator.

## ◆ following()

virtual int32_t icu::RuleBasedBreakIterator::following | ( | int32_t | offset | ) |
| override virtual

Sets the iterator to refer to the first boundary position following the specified position.

Parameters

  offset | The position from which to begin searching for a break position.

Returns
  The position of the first break after the current position.

Stable:
  ICU 2.0

Implements icu::BreakIterator.

## ◆ getBinaryRules()

virtual const uint8_t* icu::RuleBasedBreakIterator::getBinaryRules | ( | uint32_t & | length | ) |
| virtual

Return the binary form of compiled break rules, which can then be used to create a new break iterator at some time in the future.

Creating a break iterator from pre-compiled rules is much faster than building one from the source form of the break rules.

The binary data can only be used with the same version of ICU and on the same platform type (processor endian-ness)

Parameters

  length | Returns the length of the binary data. (Out parameter.)

Returns
  A pointer to the binary (compiled) rule data. The storage belongs to the RulesBasedBreakIterator object, not the caller, and must not be modified or deleted.

Stable:
  ICU 4.8

## ◆ getDynamicClassID()

virtual UClassID icu::RuleBasedBreakIterator::getDynamicClassID | ( | void |  | ) | const
| override virtual

Returns a unique class ID POLYMORPHICALLY.

Pure virtual override. This method is to implement a simple version of RTTI, since not all C++ compilers support genuine RTTI. Polymorphic operator==() and clone() methods call this method.

Returns
  The class ID for this object. All objects of a given class have the same class ID. Objects of other classes have different class IDs.

Stable:
  ICU 2.0

Implements icu::BreakIterator.

## ◆ getRules()

virtual const UnicodeString& icu::RuleBasedBreakIterator::getRules | ( | void |  | ) | const
| virtual

Returns the description used to create this iterator.

Returns
  the description used to create this iterator

Stable:
  ICU 2.0

## ◆ getRuleStatus()

virtual int32_t icu::RuleBasedBreakIterator::getRuleStatus | ( |  | ) | const
| override virtual

Return the status tag from the break rule that determined the boundary at the current iteration position.

For break rules that do not specify a status, a default value of 0 is returned. If more than one break rule would cause a boundary to be located at some position in the text, the numerically largest of the applicable status values is returned.

Of the standard types of ICU break iterators, only word break and line break provide status values. The values are defined in the header file ubrk.h. For Word breaks, the status allows distinguishing between words that contain alphabetic letters, "words" that appear to be numbers, punctuation and spaces, words containing ideographic characters, and more. For Line Break, the status distinguishes between hard (mandatory) breaks and soft (potential) break positions.

`getRuleStatus()` can be called after obtaining a boundary position from `next()`, `previous()`, or any other break iterator functions that returns a boundary position.

Note that `getRuleStatus()` returns the value corresponding to `current()` index even after `next()` has returned DONE.

When creating custom break rules, one is free to define whatever status values may be convenient for the application.

Returns
  the status from the break rule that determined the boundary at the current iteration position.

See also
  UWordBreak

Stable:
  ICU 2.2

Reimplemented from icu::BreakIterator.

## ◆ getRuleStatusVec()

virtual int32_t icu::RuleBasedBreakIterator::getRuleStatusVec | ( | int32_t * | fillInVec,
|  | int32_t | capacity,
|  | UErrorCode & | status
| ) |  |
| override virtual

Get the status (tag) values from the break rule(s) that determined the boundary at the current iteration position.

The returned status value(s) are stored into an array provided by the caller. The values are stored in sorted (ascending) order. If the capacity of the output array is insufficient to hold the data, the output will be truncated to the available length, and a U_BUFFER_OVERFLOW_ERROR will be signaled.

Parameters

  fillInVec | an array to be filled in with the status values.
  capacity | the length of the supplied vector. A length of zero causes the function to return the number of status values, in the normal way, without attempting to store any values.
  status | receives error codes.

Returns
  The number of rule status values from the rules that determined the boundary at the current iteration position. In the event of a U_BUFFER_OVERFLOW_ERROR, the return value is the total number of status values that were available, not the reduced number that were actually returned.

See also
  getRuleStatus

Stable:
  ICU 3.0

Reimplemented from icu::BreakIterator.

## ◆ getStaticClassID()

static UClassID icu::RuleBasedBreakIterator::getStaticClassID | ( | void |  | ) |
| static

Returns the class ID for this class.

This is useful only for comparing to a return value from getDynamicClassID(). For example:

     Base* polymorphic_pointer = createPolymorphicObject();
     if (polymorphic_pointer->getDynamicClassID() ==
         Derived::getStaticClassID()) ...

Returns
  The class ID for all objects of this class.

Stable:
  ICU 2.0

## ◆ getText()

virtual CharacterIterator& icu::RuleBasedBreakIterator::getText | ( | void |  | ) | const
| override virtual

Return a CharacterIterator over the text being analyzed. The returned character iterator is owned by the break iterator, and must not be deleted by the caller. Repeated calls to this function may return the same CharacterIterator.

The returned character iterator must not be used concurrently with the break iterator. If concurrent operation is needed, clone the returned character iterator first and operate on the clone.

When the break iterator is operating on text supplied via a UText, this function will fail, returning a CharacterIterator containing no text. The function getUText() provides similar functionality, is reliable, and is more efficient.

TODO: deprecate this function?

Returns
  An iterator over the text being analyzed.

Stable:
  ICU 2.0

Implements icu::BreakIterator.

## ◆ getUText()

virtual UText* icu::RuleBasedBreakIterator::getUText | ( | UText * | fillIn,
|  | UErrorCode & | status
| ) |  | const
| override virtual

Get a UText for the text being analyzed.

The returned UText is a shallow clone of the UText used internally by the break iterator implementation. It can safely be used to access the text without impacting any break iterator operations, but the underlying text itself must not be altered.

Parameters

  fillIn | A UText to be filled in. If nullptr, a new UText will be allocated to hold the result.
  status | receives any error codes.

Returns
  The current UText for this break iterator. If an input UText was provided, it will always be returned.

Stable:
  ICU 3.4

Implements icu::BreakIterator.

## ◆ hashCode()

virtual int32_t icu::RuleBasedBreakIterator::hashCode | ( | void |  | ) | const
| virtual

Compute a hash code for this BreakIterator.

Returns
  A hash code

Stable:
  ICU 2.0

## ◆ isBoundary()

virtual UBool icu::RuleBasedBreakIterator::isBoundary | ( | int32_t | offset | ) |
| override virtual

Returns true if the specified position is a boundary position.

As a side effect, leaves the iterator pointing to the first boundary position at or after "offset".

Parameters

  offset | the offset to check.

Returns
  True if "offset" is a boundary position.

Stable:
  ICU 2.0

Implements icu::BreakIterator.

## ◆ last()

virtual int32_t icu::RuleBasedBreakIterator::last | ( | void |  | ) |
| override virtual

Sets the current iteration position to the end of the text.

Returns
  The text's past-the-end offset.

Stable:
  ICU 2.0

Implements icu::BreakIterator.

## ◆ next() [1/2]

virtual int32_t icu::RuleBasedBreakIterator::next | ( | int32_t | n | ) |
| override virtual

Advances the iterator either forward or backward the specified number of steps.

Negative values move backward, and positive values move forward. This is equivalent to repeatedly calling next() or previous().

Parameters

  n | The number of steps to move. The sign indicates the direction (negative is backwards, and positive is forwards).

Returns
  The character offset of the boundary position n boundaries away from the current one.

Stable:
  ICU 2.0

Implements icu::BreakIterator.

## ◆ next() [2/2]

virtual int32_t icu::RuleBasedBreakIterator::next | ( | void |  | ) |
| override virtual

Advances the iterator to the next boundary position.

Returns
  The position of the first boundary after this one.

Stable:
  ICU 2.0

Implements icu::BreakIterator.

## ◆ operator!=()

bool icu::RuleBasedBreakIterator::operator!= | ( | const BreakIterator & | that | ) | const
| inline

Not-equal operator.

If operator== returns true, this returns false, and vice versa.

Parameters

  that | The BreakIterator to be compared for inequality

Returns
  true if both BreakIterators are not same.

Stable:
  ICU 2.0

Definition at line 370 of file rbbi.h.

References icu::BreakIterator::operator==().

## ◆ operator=()

RuleBasedBreakIterator& icu::RuleBasedBreakIterator::operator= | ( | const RuleBasedBreakIterator & | that | ) |

Assignment operator.

Sets this iterator to have the same behavior, and iterate over the same text, as the one passed in.

Parameters

  that | The RuleBasedBreakItertor passed in

Returns
  the newly created RuleBasedBreakIterator

Stable:
  ICU 2.0

## ◆ operator==()

virtual bool icu::RuleBasedBreakIterator::operator== | ( | const BreakIterator & | that | ) | const
| override virtual

Equality operator.

Returns true if both BreakIterators are of the same class, have the same behavior, and iterate over the same text.

Parameters

  that | The BreakIterator to be compared for equality

Returns
  true if both BreakIterators are of the same class, have the same behavior, and iterate over the same text.

Stable:
  ICU 2.0

Implements icu::BreakIterator.

## ◆ preceding()

virtual int32_t icu::RuleBasedBreakIterator::preceding | ( | int32_t | offset | ) |
| override virtual

Sets the iterator to refer to the last boundary position before the specified position.

Parameters

  offset | The position to begin searching for a break from.

Returns
  The position of the last boundary before the starting position.

Stable:
  ICU 2.0

Implements icu::BreakIterator.

## ◆ previous()

virtual int32_t icu::RuleBasedBreakIterator::previous | ( | void |  | ) |
| override virtual

Moves the iterator backwards, to the last boundary preceding this one.

Returns
  The position of the last boundary position preceding this one.

Stable:
  ICU 2.0

Implements icu::BreakIterator.

## ◆ refreshInputText()

virtual RuleBasedBreakIterator& icu::RuleBasedBreakIterator::refreshInputText | ( | UText * | input,
|  | UErrorCode & | status
| ) |  |
| override virtual

Set the subject text string upon which the break iterator is operating without changing any other aspect of the matching state.

The new and previous text strings must have the same content.

This function is intended for use in environments where ICU is operating on strings that may move around in memory. It provides a mechanism for notifying ICU that the string has been relocated, and providing a new UText to access the string in its new position.

Note that the break iterator implementation never copies the underlying text of a string being processed, but always operates directly on the original text provided by the user. Refreshing simply drops the references to the old text and replaces them with references to the new.

Caution: this function is normally used only by very specialized, system-level code. One example use case is with garbage collection that moves the text in memory.

Parameters

  input | The new (moved) text string.
  status | Receives errors detected by this function.

Returns
  *this

Stable:
  ICU 49

Implements icu::BreakIterator.

## ◆ registerExternalBreakEngine()

static void icu::RuleBasedBreakIterator::registerExternalBreakEngine | ( | ExternalBreakEngine * | toAdopt,
|  | UErrorCode & | status
| ) |  |
| static

Register a new external break engine.

The external break engine will be adopted. Because ICU may choose to cache break engine internally, this must be called at application startup, prior to any calls to object methods of RuleBasedBreakIterator to avoid undefined behavior.

Parameters

  toAdopt | the ExternalBreakEngine instance to be adopted
  status | the in/out status code, no special meanings are assigned

Internal:
  Do not use. This API is for internal use only. ICU 74 technology preview

## ◆ setText() [1/2]

virtual void icu::RuleBasedBreakIterator::setText | ( | const UnicodeString & | newText | ) |
| override virtual

Set the iterator to analyze a new piece of text.

This function resets the current iteration position to the beginning of the text.

The BreakIterator will retain a reference to the supplied string. The caller must not modify or delete the text while the BreakIterator retains the reference.

Parameters

  newText | The text to analyze.

Stable:
  ICU 2.0

Implements icu::BreakIterator.

## ◆ setText() [2/2]

virtual void icu::RuleBasedBreakIterator::setText | ( | UText * | text,
|  | UErrorCode & | status
| ) |  |
| override virtual

Reset the break iterator to operate over the text represented by the UText.

The iterator position is reset to the start.

This function makes a shallow clone of the supplied UText. This means that the caller is free to immediately close or otherwise reuse the Utext that was passed as a parameter, but that the underlying text itself must not be altered while being referenced by the break iterator.

Parameters

  text | The UText used to change the text.
  status | Receives any error codes.

Stable:
  ICU 3.4

Implements icu::BreakIterator.

## Friends And Related Function Documentation

## ◆ BreakIterator

friend class BreakIterator
| friend

Internal:
  Do not use.

This API is for internal use only.

Definition at line 258 of file rbbi.h.

## ◆ RBBIRuleBuilder

friend class RBBIRuleBuilder
| friend

Internal:
  Do not use.

This API is for internal use only.

Definition at line 256 of file rbbi.h.

## Field Documentation

## ◆ fData

RBBIDataWrapper* icu::RuleBasedBreakIterator::fData = nullptr

The rule data for this BreakIterator instance.

Not for general use; Public only for testing purposes.

Internal:
  Do not use. This API is for internal use only.

Definition at line 137 of file rbbi.h.

The documentation for this class was generated from the following file:

- common/unicode/rbbi.h